function vexpower.panel_show()
	return {
		type = "group",
		order= 5,
		args = {
			grptestmode = {
				name = "Testmode",
				order=1, type ="group", dialogInline = true,
				args = {
					testmode = {
						name = "activate",
						order=1, type = "toggle", width="double",
						set = function(info,val) vexpower.testmode=val vexpower_global_testmode(val) end,
						get = function() return vexpower.testmode end,
						},
					info = {name ="- ComboPoint gain and loss are simulated\n- Textfields get a colored background and are moveable\n- Powerbar gets movable\n'/vexp testmode' can be used to toggle the testmode", type = "description", order=2},
					},
				},
			spacetestmode = {name ="\n", type = "description", order=2},
			
			grpallow = {
				name = "General Settings",
				order=5, type ="group", dialogInline = true,
				args = {
					activate = {
						name = "Enable addon",
						order=1, type = "toggle", width="full",
						set = function(self,key) vexpower_parameters["frame"]["show"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["show"] end,
						},
					activate_space = {name ="\n", type = "description", order=2},
					activateenergy = {
						name = "Enable Powerbar",
						order=3, type = "toggle", width="full",
						disabled = not(vexpower_parameters["frame"]["show"]),
						set = function(self,key) vexpower_parameters["frame"]["energy"]["show"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["show"] end,
						},
					activatecps = {
						name = "Enable Combopoints",
						order=4, type = "toggle", width="full",
						disabled = not(vexpower_parameters["frame"]["show"]),
						set = function(self,key) vexpower_parameters["frame"]["combo"]["show"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["combo"]["show"] end,
						},
					},
				},
			frame_space = {name ="\n", type = "description", order=6},
			grpblizz = {
				name = "Blizzard's Frames",
				order=7, type ="group", dialogInline = true,
				args = {
					disableHolyPower = {
						name = "Disable Blizzard's Holy Power Bar",
						order=1, type = "toggle", width="full",
						disabled = not(vexpower_parameters["frame"]["show"]),
						set = function(self,key)
							vexpower_parameters["blizzhide"]["holypower"]=key
							if key then
								vexpower_initialize(true)
							else
								ReloadUI()
							end
							end,
						get = function() return vexpower_parameters["blizzhide"]["holypower"] end,
						confirm = vexpower_parameters["blizzhide"]["holypower"],
						confirmText = "Re-enabling Blizzard's frames needs a UI reload in order to work. Do you want to continue?"
						},
					disableCPs = {
						name = "Disable Blizzard's ComboPoint Bar",
						order=2, type = "toggle", width="full",
						disabled = not(vexpower_parameters["frame"]["show"]),
						set = function(self,key)
							vexpower_parameters["blizzhide"]["cps"]=key
							if key then
								vexpower_initialize(true)
							else
								ReloadUI()
							end
							end,
						get = function() return vexpower_parameters["blizzhide"]["cps"] end,
						confirm = vexpower_parameters["blizzhide"]["cps"],
						confirmText = "Re-enabling Blizzard's frames needs a UI reload in order to work. Do you want to continue?"
						},
					disableLockShards = {
						name = "Disable Blizzard's Soul Shard Bar",
						order=3, type = "toggle", width="full",
						disabled = not(vexpower_parameters["frame"]["show"]),
						set = function(self,key)
							vexpower_parameters["blizzhide"]["lockShards"]=key
							if key then
								vexpower_initialize(true)
							else
								ReloadUI()
							end
							end,
						get = function() return vexpower_parameters["blizzhide"]["lockShards"] end,
						confirm = vexpower_parameters["blizzhide"]["lockShards"],
						confirmText = "Re-enabling Blizzard's frames needs a UI reload in order to work. Do you want to continue?"
						},
					},
				},
			frame_space1 = {name ="\n", type = "description", order=8},
			
			grpooc = {
				name = "'Out of Combat' Settings",
				order=9, type ="group", dialogInline = true,
				args = {
					infightonly = {
						name = "When 'Out of Combat': Hide the Powerbar",
						order=1, type = "toggle", width="double",
						disabled = not(vexpower_parameters["frame"]["show"]),
						set = function(self,key) vexpower_parameters["frame"]["energy"]["infightshow"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["infightshow"] end,
						},
					stealth = {
						name = "Show stealthed",
						order=3, type = "toggle",
						disabled = not(vexpower_parameters["frame"]["energy"]["infightshow"]) or not(vexpower_parameters["frame"]["show"]),
						desc = "Shows the energy bar when stealthed even when the 'out of combat'-setting is enabled and you are out of combat",
						set = function(self,key) vexpower_parameters["frame"]["energy"]["stealthshow"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["stealthshow"] end,
						},
					infightonlyCP = {
						name = "When 'Out of Combat': Hide the ComboPoints",
						order=4, type = "toggle", width="double",
						disabled = not(vexpower_parameters["frame"]["show"]),
						set = function(self,key) vexpower_parameters["frame"]["combo"]["infightshow"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["combo"]["infightshow"] end,
						},
					stealthCP = {
						name = "Show stealthed",
						order=6, type = "toggle",
						disabled = not(vexpower_parameters["frame"]["combo"]["infightshow"]) or not(vexpower_parameters["frame"]["show"]),
						desc = "Shows the combopoints when stealthed even when the 'out of combat'-setting is enabled and you are out of combat",
						set = function(self,key) vexpower_parameters["frame"]["combo"]["stealthshow"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["combo"]["stealthshow"] end,
						},
					frame_subspace2 = {name =" ", type = "description", order=7},
					infightdelay = {
						name = "'Out of Combat' delay timer (seconds)",
						order=8, type = "range", width="double",
						desc = "Sets the time the fade out effects are delayed when leaving combat",
						step = 1, min = 0, max = 30,
						set = function(info,val) vexpower_parameters["frame"]["infightdelay"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["infightdelay"] end
						},
					},
				},
			frame_space2 = {name ="\n", type = "description", order=10},
			
			grppowertypes = {
				name = "Powertype settings",
				order=11, type ="group", dialogInline = true,
				args = {
					powerbar = {
						name = "Show PowerBar when powertype is",
						order=1, type ="group", dialogInline = true,
						args = {
							marker_new_powertype_rage = {
								name = "|CFF"..vexpower_PowerTypeColorHex("RAGE").."Rage|r",
								order=1, type = "toggle", width="half",
								set = function(self,key) vexpower_parameters["frame"]["energy"]["showWithPowerType"]["RAGE"] = key vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["showWithPowerType"]["RAGE"] end,
								},
							marker_new_powertype_mana = {
								name = "|CFF"..vexpower_PowerTypeColorHex("MANA").."Mana|r",
								order=2, type = "toggle", width="half",
								set = function(self,key) vexpower_parameters["frame"]["energy"]["showWithPowerType"]["MANA"] = key vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["showWithPowerType"]["MANA"] end,
								},
							marker_new_powertype_focus = {
								name = "|CFF"..vexpower_PowerTypeColorHex("FOCUS").."Focus|r",
								order=3, type = "toggle", width="half",
								set = function(self,key) vexpower_parameters["frame"]["energy"]["showWithPowerType"]["FOCUS"] = key vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["showWithPowerType"]["FOCUS"] end,
								},
							marker_new_powertype_energy = {
								name = "|CFF"..vexpower_PowerTypeColorHex("ENERGY").."Energy|r",
								order=4, type = "toggle", width="half",
								set = function(self,key) vexpower_parameters["frame"]["energy"]["showWithPowerType"]["ENERGY"] = key vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["showWithPowerType"]["ENERGY"] end,
								},
							marker_new_powertype_rp = {
								name = "|CFF"..vexpower_PowerTypeColorHex("RUNIC_POWER").."Runic Power|r",
								order=5, type = "toggle",
								set = function(self,key) vexpower_parameters["frame"]["energy"]["showWithPowerType"]["RUNIC_POWER"] = key vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["showWithPowerType"]["RUNIC_POWER"] end,
								},
							},
						},
					combopoints = {
						name = "Show ComboPointBar when powertype is",
						order=2, type ="group", dialogInline = true,
						args = {
							marker_new_powertype_rage = {
								name = "|CFF"..vexpower_PowerTypeColorHex("RAGE").."Rage|r",
								order=1, type = "toggle", width="half",
								set = function(self,key) vexpower_parameters["frame"]["combo"]["showWithPowerType"]["RAGE"] = key vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["combo"]["showWithPowerType"]["RAGE"] end,
								},
							marker_new_powertype_mana = {
								name = "|CFF"..vexpower_PowerTypeColorHex("MANA").."Mana|r",
								order=2, type = "toggle", width="half",
								set = function(self,key) vexpower_parameters["frame"]["combo"]["showWithPowerType"]["MANA"] = key vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["combo"]["showWithPowerType"]["MANA"] end,
								},
							marker_new_powertype_focus = {
								name = "|CFF"..vexpower_PowerTypeColorHex("FOCUS").."Focus|r",
								order=3, type = "toggle", width="half",
								set = function(self,key) vexpower_parameters["frame"]["combo"]["showWithPowerType"]["FOCUS"] = key vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["combo"]["showWithPowerType"]["FOCUS"] end,
								},
							marker_new_powertype_energy = {
								name = "|CFF"..vexpower_PowerTypeColorHex("ENERGY").."Energy|r",
								order=4, type = "toggle", width="half",
								set = function(self,key) vexpower_parameters["frame"]["combo"]["showWithPowerType"]["ENERGY"] = key vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["combo"]["showWithPowerType"]["ENERGY"] end,
								},
							marker_new_powertype_rp = {
								name = "|CFF"..vexpower_PowerTypeColorHex("RUNIC_POWER").."Runic Power|r",
								order=5, type = "toggle",
								set = function(self,key) vexpower_parameters["frame"]["combo"]["showWithPowerType"]["RUNIC_POWER"] = key vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["combo"]["showWithPowerType"]["RUNIC_POWER"] end,
								},
							},
						},
					},
				},
			frame_space3 = {name ="\n", type = "description", order=12},
			
			grpvehicle = {
				name = "Vehicle settings",
				order=13, type ="group", dialogInline = true,
				args = {
					vehiclehidePower = {
						name = "When in a vehicle: Show the Powerbar",
						order=1, type = "toggle", width="double",
						disabled = not(vexpower_parameters["frame"]["show"]),
						set = function(self,key) vexpower_parameters["frame"]["energy"]["vehiclehide"]=not(key) vexpower_initialize(true) end,
						get = function() return not(vexpower_parameters["frame"]["energy"]["vehiclehide"]) end,
						},
					vehicleEnergy= {
						name = "Show vehicle-power",
						order=2, type = "toggle",
						disabled = not(vexpower_parameters["frame"]["show"]) or vexpower_parameters["frame"]["energy"]["vehiclehide"],
						set = function(self,key) vexpower_parameters["frame"]["energy"]["vehicleEnergy"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["vehicleEnergy"] end,
						},
					vehiclehideCPs = {
						name = "When in a vehicle: Show the ComboPoints",
						order=10, type = "toggle", width="full",
						disabled = not(vexpower_parameters["frame"]["show"]),
						set = function(self,key) vexpower_parameters["frame"]["combo"]["vehiclehide"]=not(key) vexpower_initialize(true) end,
						get = function() return not(vexpower_parameters["frame"]["combo"]["vehiclehide"]) end,
						},
					},
				},
			frame_space4 = {name ="\n", type = "description", order=14},
			
			grpeffect = {
				name = "Hide effect",
				order=15, type ="group", dialogInline = true,
				args = {
					fadeout= {
						name = "Let the frames fadeout, instead of instantly disappear",
						order=1, type = "toggle", width="full",
						disabled = not(vexpower_parameters["frame"]["show"]),
						set = function(self,key) vexpower_parameters["frame"]["fadeout"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["fadeout"] end,
						},
					fadeoutTime = {
						name = "Fade-Out duration (seconds)",
						order=2, type = "range", width="double",
						desc = "Sets the time the fade out effects last",
						step = 0.1, min = 0.1, max = 5,
						set = function(info,val) vexpower_parameters["fadeOutTime"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["fadeOutTime"] end
						},
					},
				},
			}
		}
end